Index: Scheduling/trunk/cs/bsdx0200GUISourceCode/DSplash.cs
===================================================================
--- Scheduling/trunk/cs/bsdx0200GUISourceCode/DSplash.cs	(revision 627)
+++ Scheduling/trunk/cs/bsdx0200GUISourceCode/DSplash.cs	(revision 1050)
@@ -13,7 +13,8 @@
 	{
 		private System.Windows.Forms.Label label1;
-        //private System.Windows.Forms.Label lblVersion;
 		private System.Windows.Forms.LinkLabel lnkMail;
 		private System.Windows.Forms.Label lblStatus;
+        private Label lblVersion;
+        private Label label2;
 		/// <summary>
 		/// Required designer variable.
@@ -55,7 +56,10 @@
 		private void InitializeComponent()
 		{
+            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DSplash));
             this.label1 = new System.Windows.Forms.Label();
             this.lnkMail = new System.Windows.Forms.LinkLabel();
             this.lblStatus = new System.Windows.Forms.Label();
+            this.lblVersion = new System.Windows.Forms.Label();
+            this.label2 = new System.Windows.Forms.Label();
             this.SuspendLayout();
             // 
@@ -63,9 +67,9 @@
             // 
             this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 21.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-            this.label1.Location = new System.Drawing.Point(24, 32);
+            this.label1.Location = new System.Drawing.Point(12, 67);
             this.label1.Name = "label1";
-            this.label1.Size = new System.Drawing.Size(448, 40);
+            this.label1.Size = new System.Drawing.Size(464, 40);
             this.label1.TabIndex = 0;
-            this.label1.Text = "VistA Clinical Scheduling";
+            this.label1.Text = "Clinical Scheduling";
             this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
             // 
@@ -80,5 +84,5 @@
             // 
             this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
-            this.lblStatus.Location = new System.Drawing.Point(88, 160);
+            this.lblStatus.Location = new System.Drawing.Point(80, 159);
             this.lblStatus.Name = "lblStatus";
             this.lblStatus.Size = new System.Drawing.Size(328, 16);
@@ -86,13 +90,37 @@
             this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
             // 
+            // lblVersion
+            // 
+            this.lblVersion.AutoSize = true;
+            this.lblVersion.Location = new System.Drawing.Point(210, 117);
+            this.lblVersion.Name = "lblVersion";
+            this.lblVersion.Size = new System.Drawing.Size(52, 13);
+            this.lblVersion.TabIndex = 5;
+            this.lblVersion.Text = "lblVersion";
+            this.lblVersion.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
+            // 
+            // label2
+            // 
+            this.label2.AutoSize = true;
+            this.label2.Font = new System.Drawing.Font("Book Antiqua", 27.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+            this.label2.Location = new System.Drawing.Point(180, 21);
+            this.label2.Name = "label2";
+            this.label2.Size = new System.Drawing.Size(130, 46);
+            this.label2.TabIndex = 6;
+            this.label2.Text = "VISTA";
+            // 
             // DSplash
             // 
             this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
+            this.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
             this.ClientSize = new System.Drawing.Size(488, 252);
             this.ControlBox = false;
+            this.Controls.Add(this.label2);
+            this.Controls.Add(this.lblVersion);
             this.Controls.Add(this.lblStatus);
             this.Controls.Add(this.lnkMail);
             this.Controls.Add(this.label1);
-            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
+            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
+            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
             this.Name = "DSplash";
             this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
@@ -100,34 +128,45 @@
             this.Load += new System.EventHandler(this.DSplash_Load);
             this.ResumeLayout(false);
+            this.PerformLayout();
 
 		}
 		#endregion
 
-		public void SetStatus(string sStatus)
+        public delegate void dSetStatus(string sStatus);
+        public delegate void dAny();
+		
+        public void SetStatus(string sStatus)
 		{
-			this.Status = sStatus;
+            if (this.InvokeRequired == true)
+            {
+                dSetStatus d = new dSetStatus(SetStatus);
+                this.Invoke(d, new object[] { sStatus });
+                return;
+            }
+            
+            System.Diagnostics.Debug.Assert(this.InvokeRequired == false);
+			this.lblStatus.Text = sStatus;
+            this.Refresh();
 		}
 
 		private void DSplash_Load(object sender, System.EventArgs e)
 		{
-			//this.lblVersion.Text = "Version " + Application.ProductVersion;
+			this.lblVersion.Text = "Version " + Application.ProductVersion;
 		}
 
-		#region Properties
-		/// <summary>
-		/// Gets or sets the value of the Status displayed on the splash screen
-		/// </summary>
-		public String Status
-		{
-			get
-			{
-				return lblStatus.Text;
-			}
-			set
-			{
-				lblStatus.Text = value;
-			}
-		}
-		#endregion Properties
+        public void RemoteClose()
+        {
+            dAny d = new dAny(this.Close);
+            this.Invoke(d);
+        }
+
+        public void RemoteHide()
+        {
+            dAny d = new dAny(this.Hide);
+            this.Invoke(d);
+        }
 	}
+
+
+    
 }