Index: Scheduling/trunk/cs/bsdx0200GUISourceCode/DManagement.cs
===================================================================
--- Scheduling/trunk/cs/bsdx0200GUISourceCode/DManagement.cs	(revision 899)
+++ Scheduling/trunk/cs/bsdx0200GUISourceCode/DManagement.cs	(revision 1075)
@@ -692,5 +692,5 @@
             this.tpResourceGroups.Location = new System.Drawing.Point(4, 22);
             this.tpResourceGroups.Name = "tpResourceGroups";
-            this.tpResourceGroups.Size = new System.Drawing.Size(579, 362);
+            this.tpResourceGroups.Size = new System.Drawing.Size(696, 428);
             this.tpResourceGroups.TabIndex = 4;
             this.tpResourceGroups.Text = "Resource Groups";
@@ -706,5 +706,5 @@
             this.grdResourceGroup.Name = "grdResourceGroup";
             this.grdResourceGroup.ReadOnly = true;
-            this.grdResourceGroup.Size = new System.Drawing.Size(579, 250);
+            this.grdResourceGroup.Size = new System.Drawing.Size(696, 316);
             this.grdResourceGroup.TabIndex = 4;
             this.grdResourceGroup.CurrentCellChanged += new System.EventHandler(this.grdResourceGroup_CurrentCellChanged);
@@ -715,7 +715,7 @@
             this.pnlDescriptionResourceGroup.Controls.Add(this.grpDescriptionResourceGroup);
             this.pnlDescriptionResourceGroup.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlDescriptionResourceGroup.Location = new System.Drawing.Point(0, 250);
+            this.pnlDescriptionResourceGroup.Location = new System.Drawing.Point(0, 316);
             this.pnlDescriptionResourceGroup.Name = "pnlDescriptionResourceGroup";
-            this.pnlDescriptionResourceGroup.Size = new System.Drawing.Size(579, 72);
+            this.pnlDescriptionResourceGroup.Size = new System.Drawing.Size(696, 72);
             this.pnlDescriptionResourceGroup.TabIndex = 3;
             // 
@@ -726,5 +726,5 @@
             this.grpDescriptionResourceGroup.Location = new System.Drawing.Point(0, 0);
             this.grpDescriptionResourceGroup.Name = "grpDescriptionResourceGroup";
-            this.grpDescriptionResourceGroup.Size = new System.Drawing.Size(579, 72);
+            this.grpDescriptionResourceGroup.Size = new System.Drawing.Size(696, 72);
             this.grpDescriptionResourceGroup.TabIndex = 0;
             this.grpDescriptionResourceGroup.TabStop = false;
@@ -736,5 +736,5 @@
             this.lblDescriptionResourceGroup.Location = new System.Drawing.Point(3, 16);
             this.lblDescriptionResourceGroup.Name = "lblDescriptionResourceGroup";
-            this.lblDescriptionResourceGroup.Size = new System.Drawing.Size(573, 53);
+            this.lblDescriptionResourceGroup.Size = new System.Drawing.Size(690, 53);
             this.lblDescriptionResourceGroup.TabIndex = 0;
             this.lblDescriptionResourceGroup.Text = resources.GetString("lblDescriptionResourceGroup.Text");
@@ -746,7 +746,7 @@
             this.pnlAddEditResourceGroups.Controls.Add(this.cmdAddResourceGroup);
             this.pnlAddEditResourceGroups.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlAddEditResourceGroups.Location = new System.Drawing.Point(0, 322);
+            this.pnlAddEditResourceGroups.Location = new System.Drawing.Point(0, 388);
             this.pnlAddEditResourceGroups.Name = "pnlAddEditResourceGroups";
-            this.pnlAddEditResourceGroups.Size = new System.Drawing.Size(579, 40);
+            this.pnlAddEditResourceGroups.Size = new System.Drawing.Size(696, 40);
             this.pnlAddEditResourceGroups.TabIndex = 2;
             // 
@@ -787,5 +787,5 @@
             this.tpAccessTypes.Location = new System.Drawing.Point(4, 22);
             this.tpAccessTypes.Name = "tpAccessTypes";
-            this.tpAccessTypes.Size = new System.Drawing.Size(579, 362);
+            this.tpAccessTypes.Size = new System.Drawing.Size(696, 428);
             this.tpAccessTypes.TabIndex = 2;
             this.tpAccessTypes.Text = "Access Types";
@@ -800,5 +800,5 @@
             this.grdAccessTypes.ReadOnly = true;
             this.grdAccessTypes.RowHeadersVisible = false;
-            this.grdAccessTypes.Size = new System.Drawing.Size(579, 250);
+            this.grdAccessTypes.Size = new System.Drawing.Size(696, 316);
             this.grdAccessTypes.TabIndex = 3;
             this.grdAccessTypes.CurrentCellChanged += new System.EventHandler(this.grdAccessTypes_CurrentCellChanged);
@@ -808,7 +808,7 @@
             this.pnlDescriptionAT.Controls.Add(this.grpDescriptionAT);
             this.pnlDescriptionAT.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlDescriptionAT.Location = new System.Drawing.Point(0, 250);
+            this.pnlDescriptionAT.Location = new System.Drawing.Point(0, 316);
             this.pnlDescriptionAT.Name = "pnlDescriptionAT";
-            this.pnlDescriptionAT.Size = new System.Drawing.Size(579, 72);
+            this.pnlDescriptionAT.Size = new System.Drawing.Size(696, 72);
             this.pnlDescriptionAT.TabIndex = 2;
             // 
@@ -819,5 +819,5 @@
             this.grpDescriptionAT.Location = new System.Drawing.Point(0, 0);
             this.grpDescriptionAT.Name = "grpDescriptionAT";
-            this.grpDescriptionAT.Size = new System.Drawing.Size(579, 72);
+            this.grpDescriptionAT.Size = new System.Drawing.Size(696, 72);
             this.grpDescriptionAT.TabIndex = 0;
             this.grpDescriptionAT.TabStop = false;
@@ -829,5 +829,5 @@
             this.label1.Location = new System.Drawing.Point(3, 16);
             this.label1.Name = "label1";
-            this.label1.Size = new System.Drawing.Size(573, 53);
+            this.label1.Size = new System.Drawing.Size(690, 53);
             this.label1.TabIndex = 1;
             this.label1.Text = " Use the Access Types panel to define the kinds of access available for schedulin" +
@@ -840,7 +840,7 @@
             this.pnlAddEditAT.Controls.Add(this.cmdAddAT);
             this.pnlAddEditAT.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlAddEditAT.Location = new System.Drawing.Point(0, 322);
+            this.pnlAddEditAT.Location = new System.Drawing.Point(0, 388);
             this.pnlAddEditAT.Name = "pnlAddEditAT";
-            this.pnlAddEditAT.Size = new System.Drawing.Size(579, 40);
+            this.pnlAddEditAT.Size = new System.Drawing.Size(696, 40);
             this.pnlAddEditAT.TabIndex = 1;
             // 
@@ -870,5 +870,5 @@
             this.tpAccessGroups.Location = new System.Drawing.Point(4, 22);
             this.tpAccessGroups.Name = "tpAccessGroups";
-            this.tpAccessGroups.Size = new System.Drawing.Size(579, 362);
+            this.tpAccessGroups.Size = new System.Drawing.Size(696, 428);
             this.tpAccessGroups.TabIndex = 1;
             this.tpAccessGroups.Text = "Access Groups";
@@ -884,5 +884,5 @@
             this.grdAccessGroups.Name = "grdAccessGroups";
             this.grdAccessGroups.ReadOnly = true;
-            this.grdAccessGroups.Size = new System.Drawing.Size(579, 250);
+            this.grdAccessGroups.Size = new System.Drawing.Size(696, 316);
             this.grdAccessGroups.TabIndex = 5;
             this.grdAccessGroups.CurrentCellChanged += new System.EventHandler(this.grdAccessGroups_CurrentCellChanged);
@@ -893,7 +893,7 @@
             this.pnlDescriptionAccessGroups.Controls.Add(this.grpDescriptionAccessGroups);
             this.pnlDescriptionAccessGroups.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlDescriptionAccessGroups.Location = new System.Drawing.Point(0, 250);
+            this.pnlDescriptionAccessGroups.Location = new System.Drawing.Point(0, 316);
             this.pnlDescriptionAccessGroups.Name = "pnlDescriptionAccessGroups";
-            this.pnlDescriptionAccessGroups.Size = new System.Drawing.Size(579, 72);
+            this.pnlDescriptionAccessGroups.Size = new System.Drawing.Size(696, 72);
             this.pnlDescriptionAccessGroups.TabIndex = 4;
             // 
@@ -904,5 +904,5 @@
             this.grpDescriptionAccessGroups.Location = new System.Drawing.Point(0, 0);
             this.grpDescriptionAccessGroups.Name = "grpDescriptionAccessGroups";
-            this.grpDescriptionAccessGroups.Size = new System.Drawing.Size(579, 72);
+            this.grpDescriptionAccessGroups.Size = new System.Drawing.Size(696, 72);
             this.grpDescriptionAccessGroups.TabIndex = 0;
             this.grpDescriptionAccessGroups.TabStop = false;
@@ -914,5 +914,5 @@
             this.lblDescriptionAccessGroups.Location = new System.Drawing.Point(3, 16);
             this.lblDescriptionAccessGroups.Name = "lblDescriptionAccessGroups";
-            this.lblDescriptionAccessGroups.Size = new System.Drawing.Size(573, 53);
+            this.lblDescriptionAccessGroups.Size = new System.Drawing.Size(690, 53);
             this.lblDescriptionAccessGroups.TabIndex = 0;
             this.lblDescriptionAccessGroups.Text = resources.GetString("lblDescriptionAccessGroups.Text");
@@ -924,7 +924,7 @@
             this.pnlAddEditAccessGroup.Controls.Add(this.cmdAddAccessGroup);
             this.pnlAddEditAccessGroup.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlAddEditAccessGroup.Location = new System.Drawing.Point(0, 322);
+            this.pnlAddEditAccessGroup.Location = new System.Drawing.Point(0, 388);
             this.pnlAddEditAccessGroup.Name = "pnlAddEditAccessGroup";
-            this.pnlAddEditAccessGroup.Size = new System.Drawing.Size(579, 40);
+            this.pnlAddEditAccessGroup.Size = new System.Drawing.Size(696, 40);
             this.pnlAddEditAccessGroup.TabIndex = 3;
             // 
@@ -972,5 +972,5 @@
             this.tpTransferAppts.Location = new System.Drawing.Point(4, 22);
             this.tpTransferAppts.Name = "tpTransferAppts";
-            this.tpTransferAppts.Size = new System.Drawing.Size(579, 362);
+            this.tpTransferAppts.Size = new System.Drawing.Size(696, 428);
             this.tpTransferAppts.TabIndex = 5;
             this.tpTransferAppts.Text = "Copy Appointments";
@@ -1042,7 +1042,7 @@
             this.pnlDescriptionXfer.Controls.Add(this.grpDescriptionXfer);
             this.pnlDescriptionXfer.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlDescriptionXfer.Location = new System.Drawing.Point(0, 250);
+            this.pnlDescriptionXfer.Location = new System.Drawing.Point(0, 316);
             this.pnlDescriptionXfer.Name = "pnlDescriptionXfer";
-            this.pnlDescriptionXfer.Size = new System.Drawing.Size(579, 72);
+            this.pnlDescriptionXfer.Size = new System.Drawing.Size(696, 72);
             this.pnlDescriptionXfer.TabIndex = 2;
             // 
@@ -1053,5 +1053,5 @@
             this.grpDescriptionXfer.Location = new System.Drawing.Point(0, 0);
             this.grpDescriptionXfer.Name = "grpDescriptionXfer";
-            this.grpDescriptionXfer.Size = new System.Drawing.Size(579, 72);
+            this.grpDescriptionXfer.Size = new System.Drawing.Size(696, 72);
             this.grpDescriptionXfer.TabIndex = 0;
             this.grpDescriptionXfer.TabStop = false;
@@ -1063,5 +1063,5 @@
             this.lblDescriptionXfer.Location = new System.Drawing.Point(3, 16);
             this.lblDescriptionXfer.Name = "lblDescriptionXfer";
-            this.lblDescriptionXfer.Size = new System.Drawing.Size(573, 53);
+            this.lblDescriptionXfer.Size = new System.Drawing.Size(690, 53);
             this.lblDescriptionXfer.TabIndex = 0;
             this.lblDescriptionXfer.Text = resources.GetString("lblDescriptionXfer.Text");
@@ -1071,7 +1071,7 @@
             this.pnlCmdXfer.Controls.Add(this.cmdCopyAppts);
             this.pnlCmdXfer.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlCmdXfer.Location = new System.Drawing.Point(0, 322);
+            this.pnlCmdXfer.Location = new System.Drawing.Point(0, 388);
             this.pnlCmdXfer.Name = "pnlCmdXfer";
-            this.pnlCmdXfer.Size = new System.Drawing.Size(579, 40);
+            this.pnlCmdXfer.Size = new System.Drawing.Size(696, 40);
             this.pnlCmdXfer.TabIndex = 1;
             // 
@@ -1092,5 +1092,5 @@
             this.tpWorkStations.Location = new System.Drawing.Point(4, 22);
             this.tpWorkStations.Name = "tpWorkStations";
-            this.tpWorkStations.Size = new System.Drawing.Size(579, 362);
+            this.tpWorkStations.Size = new System.Drawing.Size(696, 428);
             this.tpWorkStations.TabIndex = 6;
             this.tpWorkStations.Text = "WorkStations";
@@ -1106,5 +1106,5 @@
             this.grdWorkStations.Name = "grdWorkStations";
             this.grdWorkStations.ReadOnly = true;
-            this.grdWorkStations.Size = new System.Drawing.Size(579, 250);
+            this.grdWorkStations.Size = new System.Drawing.Size(696, 316);
             this.grdWorkStations.TabIndex = 6;
             // 
@@ -1113,7 +1113,7 @@
             this.pnlWorkstations.Controls.Add(this.groupBox1);
             this.pnlWorkstations.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.pnlWorkstations.Location = new System.Drawing.Point(0, 250);
+            this.pnlWorkstations.Location = new System.Drawing.Point(0, 316);
             this.pnlWorkstations.Name = "pnlWorkstations";
-            this.pnlWorkstations.Size = new System.Drawing.Size(579, 72);
+            this.pnlWorkstations.Size = new System.Drawing.Size(696, 72);
             this.pnlWorkstations.TabIndex = 5;
             // 
@@ -1124,5 +1124,5 @@
             this.groupBox1.Location = new System.Drawing.Point(0, 0);
             this.groupBox1.Name = "groupBox1";
-            this.groupBox1.Size = new System.Drawing.Size(579, 72);
+            this.groupBox1.Size = new System.Drawing.Size(696, 72);
             this.groupBox1.TabIndex = 0;
             this.groupBox1.TabStop = false;
@@ -1134,5 +1134,5 @@
             this.lblWorkstations.Location = new System.Drawing.Point(3, 16);
             this.lblWorkstations.Name = "lblWorkstations";
-            this.lblWorkstations.Size = new System.Drawing.Size(573, 53);
+            this.lblWorkstations.Size = new System.Drawing.Size(690, 53);
             this.lblWorkstations.TabIndex = 0;
             this.lblWorkstations.Text = resources.GetString("lblWorkstations.Text");
@@ -1145,7 +1145,7 @@
             this.panel1.Controls.Add(this.cmdWorkStationsRefresh);
             this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
-            this.panel1.Location = new System.Drawing.Point(0, 322);
+            this.panel1.Location = new System.Drawing.Point(0, 388);
             this.panel1.Name = "panel1";
-            this.panel1.Size = new System.Drawing.Size(579, 40);
+            this.panel1.Size = new System.Drawing.Size(696, 40);
             this.panel1.TabIndex = 4;
             // 
@@ -1194,6 +1194,6 @@
             this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
             this.Text = "Scheduling Management";
+            this.Closing += new System.ComponentModel.CancelEventHandler(this.DManagement_Closing);
             this.Load += new System.EventHandler(this.DManagement_Load);
-            this.Closing += new System.ComponentModel.CancelEventHandler(this.DManagement_Closing);
             this.pnlPageBottom.ResumeLayout(false);
             this.tabMain.ResumeLayout(false);